/*Primary dll for managing notepad plugins.*/
#include "dll.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

//WIN32_FIND_DATA structure, as defined in windows.h
/*typedef struct { // wfd 

    DWORD dwFileAttributes; 
    FILETIME ftCreationTime; 
    FILETIME ftLastAccessTime; 
    FILETIME ftLastWriteTime; 
    DWORD    nFileSizeHigh; 
    DWORD    nFileSizeLow; 
    DWORD    dwReserved0; 
    DWORD    dwReserved1; 
    TCHAR    cFileName[ MAX_PATH ]; 
    TCHAR    cAlternateFileName[ 14 ]; 
} WIN32_FIND_DATA;*/

int retval;
FARPROC libproc;
WIN32_FIND_DATA data;
HINSTANCE libhandle;
HINSTANCE plugprochandle;
HANDLE filehandle;
char dllname[260];
FARPROC procaddrs[1024]; //Limits you to 1024 plugins. Can be changed if you desire.
int a;
    
DLLIMPORT int NotePlug(HWND handle)
{ 
    a = 0;
    /***************Create Plugins popup menu*********************/
    //First ID number to be assigned is 2001      
    int msgno=2001;
    //Get notepad's menu handle
    HMENU menu=GetMenu(handle);
    //Create a popup menu
    HMENU submenu=CreatePopupMenu();
    //Insert the popup menu between 'View' and 'Help'
    InsertMenu(menu,4,MF_BYPOSITION | MF_POPUP,(UINT)submenu,"&Plugins");
    //Apply changes to the menu
    SetMenu(handle,menu);
    /**************End create plugins popup menu*********************/
    
    /***************Enumerate all DLL files in the plugins directory*******************/
    //Find the first dll file in the plugins directory     
    filehandle = FindFirstFile("plugins\\*.dll",&data);
    if(filehandle == INVALID_HANDLE_VALUE){return 1;}
    strcpy(dllname,"plugins\\");
    strcat(dllname,data.cFileName);
    //Load the plugin DLL; NotePadCmd should have already loaded all DLLs, so 
    //LoadLibrary should just need to return the module handle
    libhandle = LoadLibrary(dllname);
    //Get the address of the plugin's pluginit function
    libproc = GetProcAddress(libhandle,"pluginit");
    //Call the first plugin's pluginit function
    if(libproc){
    msgno=libproc(menu,submenu,handle,msgno);
    //Increment msgno by one
    msgno++;
    }

    //Loop to enumerate the remaining dll files
    while(FindNextFile(filehandle,&data)){
    strcpy(dllname,"plugins\\");
    strcat(dllname,data.cFileName);
    //Load the plugin DLL
    libhandle = LoadLibrary(dllname);
    //Get the address of the plugin's pluginit function
    libproc = GetProcAddress(libhandle,"pluginit");
    //Call the plugin's pluginit function and  increment msgno by one
    if(libproc) {
    msgno=libproc(menu,submenu,handle,msgno);
    msgno++;
    }
    }
    /***************End DLL enumeration in the plugins directory*******************/
    return 0;
}

DLLIMPORT int NotePadCmd(HWND hwnd,int msg,int unknown)
{
    //Set a to zero each time the function is  called
    a = 0;
    
    //Notepad recieves a WM_COMMAND message with an ID of 33554447 when it initially loads.
    //When this is called, we load the addresses of each plugin procedure for later use.
    if(msg == 33554447){
    //Find the first dll file in the plugins directory     
    filehandle = FindFirstFile("plugins\\*.dll",&data);
    if(filehandle == INVALID_HANDLE_VALUE){return 1;}
    strcpy(dllname,"plugins\\");
    strcat(dllname,data.cFileName);
    //Load the plugin DLL
    plugprochandle = LoadLibrary(dllname);
    //Get the address of the plugin's plugproc function and save it in the procaddrs array
    procaddrs[a] = GetProcAddress(plugprochandle,"plugproc");
    if(procaddrs[a]){
    a++;
    }
    
    //Find all subsequent dll files in the plugins directory
    while(FindNextFile(filehandle,&data) && a < 1024){ //If you changed the number of arrays in procaddrs, change 1024 to the appropriate number as well.
    strcpy(dllname,"plugins\\");
    strcat(dllname,data.cFileName);
    //Load the plugin DLL
    plugprochandle = LoadLibrary(dllname);
    //Get the address of the plugin's plugproc function and save it in the procaddrs array
    procaddrs[a] = GetProcAddress(plugprochandle,"plugproc");
    if(procaddrs[a]){
    a++;
    }
    }
    return 0;
    }
    
    //Pass the WM_COMMAND message ID and window handle to each plugproc function
    while(procaddrs[a]){
    retval = procaddrs[a](msg,hwnd);
    //If the return value is 1, exit immediately
    if(retval){return retval;}
    a++;
    }
    return retval;
}
