/*Standard notepad plugin DLL.*/
#include "dll.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

int idno;

//Pluginit is called first and creates the menu options
DLLIMPORT int pluginit(HMENU menu,HMENU submenu,HWND handle,int msgno)
{
    //Set idno equal to msgno; idno is used in the plugproc function
    idno = msgno;
    //Add the first menu option to the 'Plugins' popup menu. Use the msgno
    //integer supplied from note_plug.dll as the menu ID for the first
    //menu option. If more than one option is created, msgno must be 
    //incremented by one for each additional menu option.
    AppendMenu(submenu, MF_STRING, msgno, "&Hello World");

    //Apply menu settings
    SetMenu(handle,menu);
    //Return the final msgno value to note_plug.dll so it knows how many
    //menu IDs were used.
    return msgno;
}

//Plugproc is passed the ID values each time notepad recieves a WM_COMMAND message.
//Note that ALL WM_COMMAND messages are passed to each plugin's plugproc function,
//allowing each plugin to also intercept and modify any existing WM_COMMAND messages.
DLLIMPORT int plugproc(int Msg,HWND hwnd)
{
          //If this ID number is the first menu option...
          if(Msg == idno)
          {
                 MessageBox(NULL,"Hello World!","Hello...",MB_OK);
                 return 1;
          }
          //Return 1 if you do not want notepad to furthur process the WM_COMMAND message (be careful!).
          //Return 0 if you do want notepad to process the WM_COMMAND message.
          return 0;
}
